//    microSD 2G
//  .. mega-avr.com.ua

#include <stdlib.h>
//SPI ports
#define SPI_PORT PORTB
#define SPI_DDR  DDRB 
#define SPI_PIN  PINB 

//SPI pins
#define DI   2
#define DO   3
#define SCK  1
#define CS   6

#define CS_LOW   SPI_PORT &= ~(1<<CS)
#define CS_HIGH  SPI_PORT |= (1<<CS)

#define MEM_N  13

unsigned char sdrx_buff[512];
//unsigned char sdtx_buff[512];
unsigned long int blokWR=0;
unsigned int sizeWR=0;
bit wr=0;

void spi_init(void); //spi ports init
unsigned char SD_Init(void); //init SD-card
void spi_sendbyte(unsigned char data); //send byte
unsigned char spi_receivebyte(void);  //
unsigned char SD_cmd(char dt0, unsigned long int arg, char dt5); //  
unsigned char SD_Write_Block (char* bf, unsigned long int blok); //    
unsigned char SD_Read_Block (char* bf, unsigned long int blok); //    
void clearRX();   //  
unsigned char MEM_AVR_Init(void);   //     ,     
void cpyNcpy(char* bfin, char* bfout, int nahalo, int konec);   //      
int cpyNum(char* bf, int nahalo, int konec);  //      (  )
char writeText(char *bf, char rewrite);   //    , rewrite - 1-    WR
char modifiedText(char *bf, unsigned long int blok); //    
char delitBlok( unsigned long int blok); //   

void spi_init() 
{
	PORTB |=  (1<<CS)|(1<<DO) | (1<<DI)/* | (1<<SD_WP) | (1<<SD_INS)*/;
	DDRB |= (1<<CS)|(1<<DI) | (1<<SCK);
}

void spi_sendbyte(unsigned char data) 
{
	unsigned char i;

	for (i = 0; i < 8; i++) {
		if ((data & 0x80) == 0x00)
			PORTB &= ~(1<<DI);
		else
			PORTB |= (1<<DI);
		data = data << 1;
		PORTB |= (1<<SCK);
		#asm("nop")
		PORTB &= ~(1<<SCK);
	}
}

unsigned char spi_receivebyte (void)
{
	unsigned char i, res = 0;

	PORTB |= (1<<DI);

	for (i = 0; i < 8; i++) {
		PORTB |= (1<<SCK);
		res = res << 1;
		if ((PINB & (1<<DO))!=0x00)
		res = res | 0x01;
		PORTB &= ~(1<<SCK);
		#asm("nop")
	}
	return res;
}

unsigned char SD_cmd(char dt0, unsigned long int arg, char dt5) //  (   40)
{
	unsigned char result;
	long int cnt;
	spi_sendbyte (dt0);		//
	 spi_sendbyte(((arg & 0xFF000000)>>24));
     spi_sendbyte(((arg & 0x00FF0000)>>16)); 
     spi_sendbyte(((arg & 0x0000FF00)>>8));
     spi_sendbyte(((arg & 0x000000FF)));
	spi_sendbyte (dt5);		// 
	cnt=0;
	do {				//    R1 (  109)
		result=spi_receivebyte();
		cnt++;
	} while ( ((result&0x80)!=0x00)&&(cnt<0xFFFF) );
	return result;
}

unsigned char SD_Init(void)
{
	unsigned char i, temp;
	long int cnt;
	for (i=0;i<10;i++)			//80  (  74)   94
	spi_sendbyte(0xFF);
	CS_LOW;			// SS
	temp=SD_cmd (0x40,0x00,0x95); // CMD0   102  96
	if (temp!=0x01) return 3;		//,    001 (
	spi_sendbyte (0xFF);
	cnt=0;
	do{
		temp=SD_cmd (0x41,0x00,0x95);	//CMD1 ( CMD0,   )
		spi_sendbyte (0xFF);
		cnt++;
	} while ( (temp!=0x00)&&(cnt<0xFFFF) );		//  R1
	if (cnt>=0xFFFF) return 4;
	return 0;
}


unsigned char SD_Write_Block (char* bf, unsigned long int blok)
{
	unsigned char result;
	long int cnt,arg; 
    SD_Init(); //      ""
    arg = blok*512;
	result=SD_cmd(0x58,arg,0x95);		//CMD24   51  97-98
	if (result!=0x00) return 6;			//,    0x00
	spi_sendbyte (0xFF);
	spi_sendbyte (0xFE);				// 
	for (cnt=0;cnt<512;cnt++)	spi_sendbyte(bf[cnt]); //
	spi_sendbyte (0xFF);				// 
	spi_sendbyte (0xFF);
	result=spi_receivebyte();
	if ((result&0x05)!=0x05) return 6;		//,    0x05 (  111)
	cnt=0;
	do {						//   BUSY
		result=spi_receivebyte();
		cnt++;
	}while ( (result!=0xFF)&&(cnt<0xFFFF) );
	if (cnt>=0xFFFF) return 6;
	return 0;
}

unsigned char SD_Read_Block (char* bf, unsigned long int blok)
{
	unsigned char result;
	long int cnt,arg; 
    char bf_n[4];
    char bf_wr[2];
    SD_Init();  //      ""
    arg = blok*512;
	result=SD_cmd (0x51,arg,0x95);		//CMD17   50  96
	if (result!=0x00) return 5;			//,    0x00
	spi_sendbyte (0xFF);
	cnt=0;
	do{						//  
		result=spi_receivebyte();
		cnt++;
	} while ( (result!=0xFE)&&(cnt<0xFFFF) );
	if (cnt>=0xFFFF) return 5; 
	for (cnt=0;cnt<512;cnt++)
    {	
       bf[cnt]=spi_receivebyte();
       if(cnt==0||cnt==1||cnt==3){ bf_n[cnt] = bf[cnt]; }
       if(cnt==5||cnt==6){ bf_wr[cnt] = bf[cnt]; }
    } //      
	spi_receivebyte();					//  
	spi_receivebyte();   
        sizeWR = atoi(bf_n); // -    ( )
       if(bf_wr[0]=='W'&&bf_wr[1]=='R'){ wr=1; }else{ wr=0; }  //    ()
	return 0;
}

void clearRX()
{
 int i=0;
 for(i=0;i<512;i++){sdrx_buff[i]=0;}
}


int cpyNum(char* bf, int nahalo, int konec)
{
 int i=0,j=0,num=0;
 char buff[32];
 
 for(i=nahalo;i<=konec;i++)
 {
   buff[j] = bf[i];
   j++;     
 }
  num = atoi(buff);
  return num;
}

void cpyNcpy(char* bfin, char* bfout, int nahalo, int konec)
{
 int i=0,j=0;
 
 for(i=nahalo;i<=konec;i++)
 {
   bfout[j] = bfin[i];
   j++;     
 }

}

unsigned char MEM_AVR_Init(void)
{
 char sd_buff[64];
 SD_Read_Block(sdrx_buff,1); //     
 if( (sdrx_buff[16]=='A')&&(sdrx_buff[17]=='M')&&(sdrx_buff[18]=='E')&&(sdrx_buff[19]=='M')&&(sdrx_buff[20]=='8') )
 {  
 // 
 blokWR = cpyNum(sdrx_buff,0,7);
  clearRX();
  return 1;
 }
 else
 { 
  char i=0;
  for(i=0;i<=16;i++){ sd_buff[i]=0; } 
   sd_buff[16]='A';
   sd_buff[17]='M';
   sd_buff[18]='E';
   sd_buff[19]='M';
   sd_buff[20]='8'; 
   SD_Write_Block(sd_buff,1);//  
   return 2;
 }
 
}

char writeText(char *bf, char rewrite)
{
 unsigned char temp=1; 
 int i=0,j=0;
 char buf[512], tempB[512]; 
  
    blokWR++; 
    if(blokWR==0||blokWR==1){blokWR=2;}
 if(rewrite==0){  SD_Read_Block (tempB, blokWR); }
 if(wr==0||rewrite==1)
 {  
  itoa(strlen(bf),buf); 
   for(i=13;i<=512;i++)
   {
     buf[i]=bf[j];   
    j++;
   } 
   buf[5]='W'; buf[6]='R';buf[7]='-'; buf[8]='-';buf[9]='-'; buf[10]='-'; 
   
  temp = SD_Write_Block (buf, blokWR);
  if(temp==0)
  {  
   char sd_buff[32];
   ltoa(blokWR,sd_buff); 
   sd_buff[16]='A';
   sd_buff[17]='M';
   sd_buff[18]='E';
   sd_buff[19]='M';
   sd_buff[20]='8';
   SD_Write_Block(sd_buff,1);//  
  }else{ blokWR--; }
  return temp; 
  
 } 
 else
 {
  return 10; //  
 } 
 
}

char modifiedText(char *bf, unsigned long int blok) // 
{
 unsigned char temp=1; 
 int i=0,j=0;
 char tempB[512]; 
 int szin=0,szsv=0,szN=0; 
 unsigned long int bl = blok;
  SD_Read_Block (tempB, blok);

  szin = strlen(bf); //   
  szsv = 500-sizeWR; 
  szN = sizeWR+14;
  itoa(szin+sizeWR,tempB);
  if(szin<=szsv)
  {
    for(i=szN;i<=512;i++)
   {
    tempB[i]=bf[j];
    j++;
   }
   if(bl==0||bl==1){ return 10; }
  temp = SD_Write_Block (tempB, bl);
  return temp; 
  }
  else{ return 20; } 
 
}

char delitBlok( unsigned long int blok)
{
 char buf[512];
 int i=0;

 for(i=0;i<=512;i++)
 { 
  buf[i]=0;
  }
 SD_Write_Block(buf,blok);
}
